**********************************************************************
* Routines de detournement/restoration des interruptions
* Auteur :	Lilian Pigallio
**********************************************************************


**********************************************************************
Grey_ON
**********************************************************************

* activation TIMER2
	D1=(5)	#0012F
	LC(1)		#7
	DAT1=C	1

* LECTURE TIMER 2 et sauvegarde
	D1=(2)	#38
	C=DAT1	8
	D0=(2)	SAV_TIMER2
	DAT0=C	8  
* chargement TIMER2
	LC(8)		#00000100
	DAT1=C	8

* Recupere adr. notre routine d'INT
	GOSUB	APRES_MYINT

********************************
* Routine de gestion des interruptions

	ST=1    14
	GOC     INT_0001C
	?ST=1   15
	GOYES INT_00021
		RTN
INT_0001C
	?ST=0   15
	RTNYES
INT_00021
* sauvegarde des registres
	RSTK=C
	CD1EX
	D1=(5)  #003DB
	DAT1=C  W			* sauvegarde D1 et le reste de C(W)
	C=0     A
	C=P     3
	P=      2
	GONC    INT_0003F
		C=C+1   P
INT_0003F
	P=      1
	C=-C-1  P
	SETHEX
	P=      0
	?SB=0   
	GOYES INT_00050
		C=C+1   P
INT_00050
	D1=D1+  16
	DAT1=C  A			* sauvegarde flags
	D1=D1+  5
	C=RSTK
	DAT1=C  A			* sauvegarde C(A)
	D1=D1+  5
	DAT1=A  W			* sauvergarde A(W)

* Teste Si l'inter est due  l'Horloge 2

	D1=(5)	#0012F
	C=DAT1	1
	?CBIT=1	3   * IT ?
	GOYES SUITE
		GOTO FIN.INT
SUITE
	LC(1)		#7
	DAT1=C	1

* on attend que la VBL passe a 0
	D1=(2)	#28
	LC(2)		#3F		* masque
ChgEcran_synchro
	A=DAT1	B
	A=A&C		B
	?A#0		B
	GOYES		ChgEcran_synchro

* on marque le passage par les INT
	C=R4.F	A
	D1=C

	D1=(2)	INT_EXECUTEE
	LC(1)		#1
	DAT1=C	1	* remise a 1

* maj sauvegarde compteur   
	D1=(2)	SAV_TIMER2
	A=DAT1	8
	P= 		7
	C=0 		WP
	CBIT=1 	7	* =80
	A=A-C 	WP	* -80
	DAT1=A 	8     * maj sauvegarde TIMER2
	P= 		0

	D1=(2)	INT_CPT
	C=DAT1	1
	?CBIT=1	1
	GOYES		Int_ecran_gris
		C=C+1		P
		DAT1=C	1

* on inverse les ecrans
		?ST=0		0
		GOYES		Int_ecran0
			D1=(2)	ECRAN0
			GOTO		Int_ecran_fin 
Int_ecran0
		D1=(2)	ECRAN1
		GOTO		Int_ecran_fin 

Int_ecran_gris
	C=0		P
	DAT1=C	1
	D1=(2)	ECRAN_GRIS

Int_ecran_fin 
	C=DAT1	A
	D1=(5)	#00120
	DAT1=C	A


* RECHARCHE HORLOGE 2
	D1=(2)	#38
	C=0		W
	LC(2) 	#78
	DAT1=C	8

    
*Recuperation des registres et fin
FIN.INT
	D1=(5)	#003F5
	A=DAT1	W		* recuperation A(W)
	D1=D1-	5
	C=DAT1	A		* recuperation C(A)
	RSTK=C
	D1=D1-	5
	C=DAT1 	A		* recupration flags
	SB=0
	CSR		A
	P=		0
	C=C+1		P
	GOC		PAS_SETDEC
		SETDEC
PAS_SETDEC
	P=		1
	C=C-1		P
	P=C		2
	D1=(4)	#03DB
	C=DAT1	W		* recupration D1 et le reste de C(W)
	D1=C
	C=RSTK
	RTI

* fin routine de gestion des interruptions
********************************

APRES_MYINT
	C=RSTK
	A=C	A

	LC(5) #80000
	A=A-C A		* nouvelle adresse du gestionnaire d'INT apres deplacement
	D0=(5)	#8019C
	DAT0=A 	A		* ecriture adresse gestionnaire

* on sauve ce qu'on ecrase en #8000F
	D0=(5)	#8000F
	A=DAT0 	W
	D1=(5) 	#8018C
	DAT1=A 	W

* on ecrit OUT=C (801) + A=IN (802) + RTN (01)
	P= 		6
	LC(8)		#10208108
	P= 		0
	D1=(2)	#9C		* lecture adresse gestionnaire
	C=DAT1 	A
	D=C 		A
	CSL 		W
	CSL 		W
	LC(2)		#D8		* prefixe GOVLNG
	DAT0=C 	W

	C=R4.F	A
	D0=C			* on remet D0 dans les variables

* - #80000 pour toutes les adresses
	LA(5)		#80000
	C=RSTK
	C=C-A 	A
	RSTK=C		* decalage pile de retour

	D0=(2)	ECRAN0
	C=DAT0	A
	C=C-A 	A
	DAT0=C	A
	D0=(2)	ECRAN1
	C=DAT0	A
	C=C-A 	A
	DAT0=C	A
	D0=(2)	ECRAN_FOND
	C=DAT0	A
	C=C-A 	A
	DAT0=C	A
	D0=(2)	ECRAN_CHUTE
	C=DAT0	A
	C=C-A 	A
	DAT0=C	A
	D0=(2)	ECRAN_GRIS
	C=DAT0	A
	C=C-A 	A
	DAT0=C	A
	D0=(2)	IMAG_BILLES
	C=DAT0	A
	C=C-A 	A
	DAT0=C	A
	D0=(2)	IMAG_BAS
	C=DAT0	A
	C=C-A 	A
	DAT0=C	A
	D0=(2)	TABLEAU
	C=DAT0	A
	C=C-A 	A
	DAT0=C	A
	D0=(2)	SERIE_B_DEBUT
	C=DAT0	A
	C=C-A 	A
	DAT0=C	A
	D0=(2)	SERIE_B_NEXT 
	C=DAT0	A
	C=C-A 	A
	DAT0=C	A
	D0=(2)	PARAMS_SORTIE
	C=DAT0	A
	C=C-A 	A
	DAT0=C	A
	D0=(2)	IMAGE_MONSTRE
	C=DAT0	A
	C=C-A 	A
	DAT0=C	A
	D0=(2)	TAB_COS
	C=DAT0	A
	C=C-A 	A
	DAT0=C	A
	D0=(2)	TAB_SIN
	C=DAT0	A
	C=C-A 	A
	DAT0=C	A

	C=R4.F	A
	C=C-A 	A
	R4=C.F	A	* decalage adressedes variables
	D0=C			* on remet D0 dans les variables decalees


* on copie a adresses fixes les deplacements de modules
	GOSUB		INITINTbis_fin
**************************************
* Routine de deplacement de #80000 en #00000

	C=R4.F	A
	D0=C

* il faut deplacer les 2 blocs
* config des 2 modules non configures : CE1 et CE2
	LC(5)		#FF000
	CONFIG
	LC(5)		#9F000
	CONFIG
	LC(5)		#FF000
	CONFIG
	LC(5)		#9F000
	CONFIG

* on est toujours dans le 1er bloc entre 80000 et BFFFF

* deplacement du 2e bloc
	LC C0000
	B=C 		A
	UNCNFG       		* deconf en C0000
	CONFIG       		* conf de taille en complement C0000
	LC(5)		#40000
	CONFIG       		* conf en 40000

* deplacement du 1er bloc
	LC(5)		#810A5  	* RTI (0F)
	RSTK=C
	LC(5)		#8222D  	* CONFIG RTNCC (80503)
	RSTK=C
	LC(5)		#01EDC  	* C=0.A RTN (D201)
	RSTK=C
	LC(5)		#0222D  	* CONFIG RTNCC (80503)
	RSTK=C
	LC(5)		#00F81  	* BCEX.A RTN (DD01)
	RSTK=C
	LC(5)		#80000
	GOVLNG 	#011DB 	* UNCNFG RTN (80401)
INITINTbis_fin

	C=RSTK
	D0=C
	D1=(5)	#833DA      * SCREEN3
	LC(5)		#00200
	GOSBVL 	=$jMOVEDOWN


	GOSUB		STOPINTbis_fin
**************************************
* Routine de deplacement pour remise en place

* on est toujours dans le 1er bloc entre 00000 et 3FFFF

* plus de gestionnaire d'INT
	D0=(5)	#0000F
	LC 10				* RTN
	DAT0=C B
	C=R4.F	A
	D0=C

* deplacement du 2e bloc
	LC(5)		#40000
	UNCNFG			* deconf en 40000
	LC(5)		#C0000
	B=C 		A
	CONFIG			* conf de taille en complement C0000
	CONFIG			* conf en C0000

* deconf des banc switcher
	LC(5)		#9F000
	UNCNFG			* deconf du banc switcher
	UNCNFG			*

* deplacement du 1er bloc
	LC(5)		#80000
	D=C 		A
	LC(5)		#0222D	* CONFIG RTNCC (80503)
	RSTK=C
	LC(5)		#00C1C	* CDEX.A RTN (DF01)
	RSTK=C
	LC(5)		#0222D	* CONFIG RTNCC (80503)
	RSTK=C
	LC(5)		#00F81	* BCEX.A RTN (DD01)
	RSTK=C
	C=0 		A
	GOVLNG	#811DB	* UNCNFG RTN (80401)
STOPINTbis_fin

	C=RSTK
	D0=C
	D1=(5)	#83C6E       * SCREEN4
	LC(5)		#00200
	GOSBVL 	=$jMOVEDOWN

	GOVLNG 	#833DA     	 * INITINTbis deplac





**********************************************************************
Grey_OFF
**********************************************************************

	ST=0   	15

* RESTORE HORLOGE
	D0=(2)	SAV_TIMER2
	C=DAT0	8
	D1=(5)	#00138
	DAT1=C	8

	C=0 	X
	OUT=C

* on restaure les variables
	LA(5)		#80000
	C=R4.F	A
	C=C+A		A
	R4=C.F	A

	C=RSTK
	C=C+A 	A
	RSTK=C			* on retourne dans la RAM au bon endroit

* on restaure en 0000F
	D0=(5)	#0018C
	A=DAT0 	W
	D1=(5)	#0000F
	DAT1=A 	W

* on remet la RAM en place
	GOVLNG	#03C6E	* STOPINTbis deplac



