**********************************************************************
* Routines de detournement/restoration des interruptions
* Auteur :	Lilian Pigallio
**********************************************************************


**********************************************************************
Grey_ON
**********************************************************************

* activation TIMER2
	D1=(5)	#0012F
	LC(1)		#7
	DAT1=C	1

* LECTURE TIMER 2 et sauvegarde
	D1=(2)	#38
	C=DAT1	8
	D0=(2)	SAV_TIMER2
	DAT0=C	8  
* chargement TIMER2
	LC(8)		#00000010
	DAT1=C	8

* Recupere adr. notre routine d'INT
	GOSUB	APRES_MYINT

********************************
* Routine de gestion des interruptions

* Teste Si l'inter est due  l'Horloge 2

	D1=(5)	#0012F
	C=DAT1	1
	?CBIT=1	3   * IT ?
	GOYES SUITE
		GOTO FIN.INT
SUITE
	LC(1)		#7
	DAT1=C	1

* on attend que la VBL passe a 0
	D1=(2)	#28
	LC(2)		#3F		* masque
ChgEcran_synchro
	A=DAT1	B
	A=A&C		B
	?A#0		B
	GOYES		ChgEcran_synchro

* on marque le passage par les INT
	C=R4.F	A
	D1=C

	D1=(2)	INT_EXECUTEE
	LC(1)		#1
	DAT1=C	1	* remise a 1

* maj sauvegarde compteur   
	D1=(2)	SAV_TIMER2
	A=DAT1	8
	P= 		7
	C=0 		WP
	CBIT=1 	7	* =80
	A=A-C 	WP	* -80
	DAT1=A 	8     * maj sauvegarde TIMER2
	P= 		0

	D1=(2)	INT_CPT
	C=DAT1	1
	?CBIT=1	1
	GOYES		Int_ecran_gris
		C=C+1		P
		DAT1=C	1

* on inverse les ecrans
		?ST=0		0
		GOYES		Int_ecran0
			D1=(2)	ECRAN0
			GOTO		Int_ecran_fin 
Int_ecran0
		D1=(2)	ECRAN1
		GOTO		Int_ecran_fin 

Int_ecran_gris
	C=0		P
	DAT1=C	1
	D1=(2)	ECRAN_GRIS

Int_ecran_fin 
	C=DAT1	A
	D1=(5)	#00120
	DAT1=C	A


* RECHARCHE HORLOGE 2
	D1=(2)	#38
	C=0		W
	LC(2) 	#78
	DAT1=C	8

    
*Recuperation des registres et fin
FIN.INT
	D1=(5)	#805F5
	A=DAT1	W
	D1=D1-	5
	C=DAT1	A
	RSTK=C
	D1=D1-	5
	C=DAT1 	A
	SB=0
	CSR		A
	P=		0
	C=C+1		P
	GOC		PAS_SETDEC
		SETDEC
PAS_SETDEC
	P=		1
	C=C-1		P
	P=C		2
	D1=(4)	#05DB
	C=DAT1	W
	D1=C
	C=RSTK
	RTI

* fin routine de gestion des interruptions
********************************

APRES_MYINT
	C=RSTK

* Sauvegarde des 16 quartets en 8600D
	D1=(5)	#8600D
	A=DAT1	16
	D0=(2)	SAV_IT
	DAT0=A	16

* Detournement des INT
	DAT1=C	A
	D1=D1+	10
	DAT1=C	A

	RTN



**********************************************************************
Grey_OFF
**********************************************************************
* reactive TIMER2
	LC(2)		#10
	D1=(5)	#0012E
	DAT1=C	B

* RESTAURE IT
	D0=(2)	SAV_IT
	A=DAT0	16
	D1=(5)	#8600D
	DAT1=A 	16

* RESTORE HORLOGE
	D0=(2)	SAV_TIMER2
	C=DAT0	8
	D1=(5)	#00138
	DAT1=C	8
	RTN
