**********************************************************************
* Routines de d'animation du monstre
* Auteur :	Lilian Pigallio
**********************************************************************


**********************************************************************
Anim_monster
**********************************************************************

	D0=(2)	SAV_TIMER2
	D0=D0+	3
	A=DAT0	1
	B=A		B

* test si gagne/perdu
	D0=(2)	PARAMS_SORTIE
	C=DAT0	A
	D1=C
	C=DAT1	1
	?C=0		P
	GOYES		Anim_pas_gagne
		?CBIT=1	1
		GOYES		Anim_perdu
			LC(5)		#000360 		* gagne 6* (24pixels/4 * 24)
			GOTO		Anim_monster_fin
Anim_perdu
*anim du perdu
	?ABIT=1	0
	GOYES Anim_monster_8
		LC(5)		#0003F0 		* gagne 7* (24pixels/4 * 24)
		GOTO	Anim_monster_fin
Anim_monster_8
	LC(5)		#00480 		* 8* (24pixels/4 * 24)
	GOTO		Anim_monster_fin
Anim_pas_gagne

* test si 9 lignes
	D0=(2)	TABLEAU
	A=DAT0	A		* dbut tableau
	LC(5)		#000B6	* (9 lignes * 20 quartets) + 2
	A=A+C		A
	D1=A				* D1 dans tableau a la 5e ligne

	C=0		W
	C=DAT1	14		* on teste seulement 7 billes
	?C=0		W
	GOYES		Anim_7lignes

* monstre type 4
		A=B		B
		?ABIT=1	0
		GOYES Anim_monster_5
			LC(5)		#001B0 	* 3* (24pixels/4 * 24)
			GOTO	Anim_monster_fin
Anim_monster_5
		LC(5)		#002D0 		* 5* (24pixels/4 * 24)
		GOTO	Anim_monster_fin

Anim_7lignes
* test 7 lignes
	D1=D1-	16				* - 2 lignes
	D1=D1-	16				*
	D1=D1-	8				*
	C=DAT1	14		* on teste seulement 7 billes
	?C=0		W
	GOYES		Anim_5lignes

* monstre type 3
		A=B		B
		?ABIT=1	0
		GOYES Anim_monster_4
			LC(5)		#001B0 	* 3* (24pixels/4 * 24)
			GOTO	Anim_monster_fin
Anim_monster_4
		LC(5)		#00240 		* 4* (24pixels/4 * 24)
		GOTO	Anim_monster_fin

Anim_5lignes
* test 5 lignes
	D1=D1-	16				* - 2 lignes
	D1=D1-	16				*
	D1=D1-	8				*
	C=DAT1	14		* on teste seulement 7 billes
	?C=0		W
	GOYES		Anim_4lignes

* monstre type 2
		A=B		B
		?ABIT=1	0
		GOYES Anim_monster_2
			C=0	A
			GOTO	Anim_monster_fin
Anim_monster_2
		LC(5)		#00120 		* 2* (24pixels/4 * 24)
		GOTO	Anim_monster_fin

Anim_4lignes
* monstre type 1
		A=B		B
		?ABIT=1	0
		GOYES Anim_monster_1
			C=0	A
			GOTO	Anim_monster_fin
Anim_monster_1
		LC(5)		#00090 		* 1* (24pixels/4 * 24)

* affichage
Anim_monster_fin
	GOSUB		Animonst_tout
	RTN


**********************************************************************
Animonst_tout
**********************************************************************
* on affiche le monstre choisi dans C(A)
	R0=C.F	A

* affiche dans ECRAN0
	D0=(2)	ECRAN0
	GOSUB		Animonst_un

* affiche dans ECRAN1
	C=R0.F	A
	D0=(2)	ECRAN1
	GOSUB		Animonst_un

* affiche dans ECRAN_GRIS
	A=R0.F	A
	LC(5)		#00510	* 9 images * (24pixels/4) * 24
	C=C+A		A
	D0=(2)	ECRAN_GRIS
	GOSUB		Animonst_un
	RTN


**********************************************************************
Animonst_un
**********************************************************************
* on affiche dans 1 ecran

* D1 dans l'ecran au bon endroit
	CD1EX
	A=DAT0	A
	LC(5)		#00569	* 40 lignes (=136/4*40) + (100 pixels/4)
	C=C+A		A
	CD1EX

* D0 sur le sprite du monstre
	D0=(2)	IMAGE_MONSTRE
	A=DAT0	A
	C=C+A		A
	D0=C
	LC(2)		#17		* 24 lignes -1
	B=C		B
Animonst_un_ret
	C=DAT0	6
	DAT1=C	6
	D0=D0+	6
	D1=D1+	16
	D1=D1+	16
	D1=D1+	2
	B=B-1		B
	GONC		Animonst_un_ret

	C=R4.F	A
	D0=C
	RTN